<template>
	<div class="ViewStratificationDetailsButton">
		<a @click="handleClick">View Details</a>
		<!-- Set a max width appropriate for mobile and desktop -->
		<v-dialog v-model="isDialogVisible" max-width="50em" :fullscreen="$vuetify.breakpoint.mdAndDown" scrollable>
			<v-card>
				<v-toolbar color="#f5f5f5" class="">
					<v-toolbar-title>Stratification Details</v-toolbar-title>
					<v-spacer />
					<v-btn icon @click="isDialogVisible = false" class="mr-1">
						<v-icon>mdi-close</v-icon>
					</v-btn>
				</v-toolbar>
				<v-card-text class="flex-grow-1">
					<v-progress-circular v-if="isLoading" indeterminate :width="7" :size="80" color="primary" />
					<stratification-details
						v-else
						:field="field"
						:area="area"
						:locations="locations"
						:stratification="stratification"
					/>
				</v-card-text>
			</v-card>
		</v-dialog>
	</div>
</template>

<script lang="ts">
import { computed, defineComponent, ref } from '@vue/composition-api';
import { useAllResources } from '../../store/modules/resources';
import StratificationDetails from './StratificationDetails.vue';

export default defineComponent({
	components: {
		StratificationDetails,
	},
	props: {
		stratificationId: {
			required: true,
			type: String,
		},
	},
	setup(props, { root }) {
		const { isLoading } = useAllResources(root.$store);
		const stratification = computed(() =>
			root.$store.getters['resources/getStratificationById'](props.stratificationId)
		);
		const field = computed(() => root.$store.getters['resources/getFieldByAreaId'](stratification.value.object));
		const area = computed(() => root.$store.getters['resources/getAreaById'](stratification.value.object));
		const locations = computed(() => root.$store.getters['resources/getLocationsByFieldId'](field.value.id));
		const isDialogVisible = ref<boolean>(false);

		const handleClick = () => {
			isDialogVisible.value = true;
		};

		return {
			isLoading,
			handleClick,
			isDialogVisible,
			field,
			area,
			locations,
			stratification,
		};
	},
});
</script>

<style>
.ViewStratificationDetailsButton a {
	font-weight: 500;
}
</style>
